/*
 * Neuhold.cpp
 * Created: 10.05.2013 11:24:51
 *  Author: kner
 */ 
  #include "Arduino.h"
  #include "Neuhold.h"
  #include "HT1621.h"
  #include <avr/pgmspace.h> 
  Neuhold::Neuhold( uint8_t data,uint8_t wr, uint8_t cs){
	  ht1621 = new HT1621(uint8_t(data),uint8_t(wr),uint8_t(0),uint8_t(cs)); 
	  ht1621->begin(); 
	  clear();
  }
  void Neuhold::clear(){
	    displayString("    ");	  
  }
  void Neuhold::displayString(String s){
	  
	  s = s.substring(0,4);
	  for (uint8_t i=0; i<s.length();i++){
		displayChar(s[i],i);  
	  }
  }
  void Neuhold::displayChar(char c,uint8_t pos){
     //16 element display => 4 memory locations a 4 bit
	 //pos=0 => mem locations 0,1,2,3    ... 16 elements
	 //pos=1 => mem locations  4         ...  3 elements   possible chars: :!'`
	 //pos=2 => mem locatons  5,6,7,8
	 //pos=3 => mem locatons  9,10,11,12
	
	 //convert char to ht1621-data (4 byte)
	 uint8_t data[4];
	 convert(data,c);
	 switch (pos){
		 case 0: ht1621->write(0,data,4);break;
		 case 1: ht1621->writeMem(4,data[0]); break;
		 case 2: ht1621->write(5,data,4);break;
		 default:ht1621->write(9,data,4); 
	 }

  }
  /* convert a char to the 16segment code */
  void Neuhold::convert(uint8_t* data,char c){
	  int sz= sizeof(LUT)/5; 
	  //search the character
	  bool found=false;
	  for (uint8_t i=0; i<sz;i++){
		 
		PGM_VOID_P pointerLUT  = LUT; 
		uint8_t ch=pgm_read_byte((uint8_t*)pointerLUT+i*5);
		if (ch==c) {
		   data[0]=pgm_read_byte((uint8_t*)pointerLUT+i*5+1);
		   data[1]=pgm_read_byte((uint8_t*)pointerLUT+i*5+2);
		   data[2]=pgm_read_byte((uint8_t*)pointerLUT+i*5+3);
		   data[3]=pgm_read_byte((uint8_t*)pointerLUT+i*5+4);
		   found=true; 
		   break;
		}
	  }
	  if (!found) data[0]=data[1]=data[2]=data[3]=0;
	}
   
  