/*
 * neuhold.h
 * Created: 10.05.2013 11:23:10
 *  Author: kner
 */ 


#ifndef NEUHOLD_H_
#define NEUHOLD_H_
#include <inttypes.h>
#include "HT1621.h"

/*
*     ----A-----
*   |             |			               Adresse 0:  G K F E
*   G \    |    / B        x                       1:  H L N D
*   |  H   I   J  |        |                       2:  I M O P
*   |   \  |  /   |                                3:  A J B C
*     -K- -L- -M-          |                      
*   |   /  |  \   |        y                       4:    x y z 
*   |  N   O   P  |        |                       
*   F /    |    \ C        z                       5:  G K F E
*   |             |        |                       6:  H L N D
*     -E- ---D---                                  7:  I M O P
*                                                  8:  A J B C
*
*                                                  9:  G K F E
*                                                 10:  H L N D
*                                                 11:  I M O P
*                                                 12:  A J B C
*
*/



const uint8_t  LUT[][5] PROGMEM = {
	{'|',0b0000,
		 0b0000,
		 0b1010,
		 0b0000 },
	{'-',0b0100,
		 0b0100,
		 0b0100,
		 0b0000 },
	{'/',0b0000,
		 0b0110,
		 0b0000,
		 0b0100 },
	{'\\',0b0000,
		 0b1100,
		 0b0001,
		 0b0000 },
	{' ',0b0000,
		 0b0000,
		 0b0000,
		 0b0000 },
	{'A',0b1110,
		 0b0100,
		 0b0100,
		 0b1011 },
	{'B',0b1111,0b0101,0b0100,0b1011},
	{'C',0b1011,0b0001,0b0000,0b1000},
	{'E',0b1111,
		0b0101,
		0b0100,
	0b1000 },
	{'F',0b1110,
		 0b0100,
		 0b0000,
	     0b1000 },
 	{'M',0b1010,
		 0b1100,
		 0b0000,
		 0b0111 },
    {'O',0b1011,
		 0b0001,
		 0b0000,
		 0b1011 },
	{'1',0b0000,
		 0b0000,
		 0b0000,
	     0b0111 },
	{'3',	0b0101,
			0b0101,
			0b0001,
			0b1100 },
	{'4',	0b1100,
			0b0100,
			0b1110,
			0b0000 },
	{':',0b0110,0x0,0x0,0x0},  //2nd element (x,y,z); only first byte used
							   //if you need it for other positions, take another char as symbol 

};


class Neuhold{
typedef uint8_t  ary4[4];
   public:
   Neuhold(uint8_t data,uint8_t wr, uint8_t cs);
   void clear();
   void displayString(String s);
   void displayChar(char c,uint8_t pos);
   HT1621 *ht1621;
   void convert(uint8_t*,char c);
   
   	

};




#endif /* NEUHOLD_H_ */